import json.JSONArray;
import json.JSONObject;
import java.util.*;

public class SocialBot 
{
    private String username;
    private String password;
    private NetzwerkZugriff socialbotnet;

    public SocialBot(String usernameNeu, String passwordNeu) {
        this.username = usernameNeu;
        this.password = passwordNeu;
        this.socialbotnet = new NetzwerkZugriff("https://www.socialbotnet.de");
    }

    /**
     * Posts der eigenen Pinwand abrufen und auf der Konsole (unformatiert) ausgeben.
     */
    public void postsAusgeben() 
    {
        String antwort;
        antwort=socialbotnet.GETAnfrageSenden("/api/pinnwand/"+this.username);

        System.out.println(antwort);
    }

    /**
     * Posts der eigenen Pinwand abrufen und auf der Konsole formatiert ausgeben.
     */
    public void postsFormatiertAusgeben() 
    {
        String antwort;
        // Alle Posts auf der eigenen Pinnwand abrufen
        antwort=socialbotnet.GETAnfrageSenden("/api/pinnwand/"+this.username);
        // Die Antwort ist ein JSON-Array von Posts
        JSONArray posts = new JSONArray(antwort);
        // Iteration ber die einzelnen Posts. 
        // Die Methode posts.length() gibt die Lnge des Arrays zurck

        for (int i=0; i < posts.length(); i++) 
        {
            // Jeder einzelne Post ist ein JSONObject
            JSONObject p = posts.getJSONObject(i);

            // Von jedem Post werden nun die einzelnen Daten (Attributewerte) ausgegeben
            System.out.println("id: " + p.getInt("id"));
            System.out.println("likedBy: " + p.getJSONArray("likedBy"));
            System.out.println("message: " + p.getString("message"));
            System.out.println("publishingDate: " + p.getString("publishingDate"));
            System.out.println("user: " + p.getJSONObject("user"));
            System.out.println("wall: " + p.getJSONObject("wall"));
            System.out.println("----------------------------------------");
        }
    }

    

    /**
     * Methode zum Postet eine Nachricht.
     *
     * @param nachricht Nachricht
     */
    public void posten(String nachricht) 
    {
        // Daten mssen zuerst in POST-Anfrage geschrieben werden
        // Fr /api/post ist das username, password, und message
        socialbotnet.POSTAnfrageVorbereiten("username", this.username);
        socialbotnet.POSTAnfrageVorbereiten("password", this.password);
        socialbotnet.POSTAnfrageVorbereiten("message", nachricht);
        socialbotnet.POSTAnfrageSenden("/api/post");
    }

   

    /**
     * Methode zum Liken eine Nachricht.
     *
     * @param id id der Nachricht
     */
    public void liken(int id) 
    {
        // An /api/like mssen username, password und postid mitgeschickt werden
        socialbotnet.POSTAnfrageVorbereiten("username", this.username);
        socialbotnet.POSTAnfrageVorbereiten("password", this.password);
        socialbotnet.POSTAnfrageVorbereiten("postid", id);
        socialbotnet.POSTAnfrageSenden("/api/like");
    }
    
    
}
